function [ R ] = R_zyx( alpha )


    phi = alpha(1);         % Roll around Z-axis (3. rot. around fixed axes)
    theta = alpha(2);       % Pitch around Y-axis
    psi = alpha(3);         % Yaw around X-axis
    
    c1 = cos(phi);
    s1 = sin(phi);
    c2 = cos(theta);
    s2 = sin(theta);
    c3 = cos(psi);
    s3 = sin(psi);

    R = [c1*c2, -s1*c3+c1*s2*s3, s1*s3+c1*s2*c3;
        s1*c2, c1*c3+s1*s2*s3, -c1*s3+s1*s2*c3;
        -s2, c2*s3, c2*c3];
end