% Animation


% Calculation
T = zeros(4, 4, n_links, length(time));
links = zeros(3, n_links+1, length(time));
cgs = zeros(3, n_links, length(time));
coor_axis = zeros(2, 3, 3, n_links+1, length(time));
tool = zeros(length(time), 3);

for t = 1:length(time(1:gamma))
    T(:,:,1,t) = T1(q_t(t,:));
    T(:,:,2,t) = T2(q_t(t,:));
    T(:,:,3,t) = T3(q_t(t,:));
    T(:,:,4,t) = T4(q_t(t,:));
    T(:,:,5,t) = T5(q_t(t,:));
    T(:,:,6,t) = T6(q_t(t,:));
    
    [X Y Z] = get_axis([0 0 0], eye(3));
    coor_axis(:,:,1,1,t) = X;
    coor_axis(:,:,2,1,t) = Y;
    coor_axis(:,:,3,1,t) = Z;
    for link = 1:n_links
        [X Y Z] = get_axis(T(1:3,4,link,t), T(1:3,1:3,link,t));
        coor_axis(:,:,1,link+1,t) = X;
        coor_axis(:,:,2,link+1,t) = Y;
        coor_axis(:,:,3,link+1,t) = Z;
        links(:,link+1,t) = T(1:3,4,link,t);
        cgs(:, link, t) = eval(['rc(q_t(t,:),' num2str(link) ')']);
    end
    tool(t,:) = links(:,n_links+1,t);
end


% Drawing
speed = 1;
figure
axis([-1 1 -1 1 -0 2]), axis equal;
xlabel('X'), ylabel('Y'), zlabel('Z');
grid on, hold on;

h_timer = text(1.5,0,2, '0.0','color','k','erase','xor');
h_wall = patch([-1, 1, 1, -1], [x_wall, x_wall, x_wall, x_wall], [0, 0, 2, 2],'y','erase','none');
h_links = plot3(links(1,:,1),links(2,:,1),links(3,:,1),'color','k','erase','xor','linewidth',2); % ,'LineStyle',':'
% h_cgs = plot3(cgs(1,:,1), cgs(2,:,1), cgs(3,:,1), 'rh');
h_axis = zeros(3, n_links+1);
for link = 1:n_links+1
    h_axis(1,link) = line(coor_axis(:,1,1,link,1),coor_axis(:,2,1,link,1),coor_axis(:,3,1,link,1),'color','b','erase','xor');
    h_axis(2,link) = line(coor_axis(:,1,2,link,1),coor_axis(:,2,2,link,1),coor_axis(:,3,2,link,1),'color','g','erase','xor');
    h_axis(3,link) = line(coor_axis(:,1,3,link,1),coor_axis(:,2,3,link,1),coor_axis(:,3,3,link,1),'color','r','erase','xor');
end
h_tool = plot3(tool(1,1),tool(1,2),tool(1,3),'color','b','LineStyle',':','erase','none');
h_ref = plot3(r(1,1),r(2,1),r(3,1),'color','r','LineStyle',':','erase','none');
patch([-0.4, -0.6, -0.6, -0.4], [-0.5, -0.5, 0.5, 0.5], [0, 0, 0, 0], 'w','erase','none');
h_meter = patch([-0.41, -0.59, -0.59, -0.41], [0.5, 0.5, 0.5-(F(1,2)/F_meter_max), 0.5-(F(1,2)/F_meter_max)], [0, 0, 0, 0], 'r','erase','xor');

pause;
for t = 1:length(time(1:gamma))
    set(h_links,'xdata',links(1,:,t),'ydata',links(2,:,t),'zdata',links(3,:,t));
%     set(h_cgs,'xdata',cgs(1,:,t),'ydata',cgs(2,:,t),'zdata',cgs(3,:,t));
    set(h_tool,'xdata',tool(1:t,1),'ydata',tool(1:t,2),'zdata',tool(1:t,3));
    set(h_ref,'xdata',r(1,1:t),'ydata',r(2,1:t),'zdata',r(3,1:t));
    set(h_meter,'ydata',[0.5, 0.5, 0.5-(F(t,2)/F_meter_max), 0.5-(F(t,2)/F_meter_max)]);
    for link = 2:n_links+1
        set(h_axis(1,link), 'xdata',coor_axis(:,1,1,link,t),'ydata',coor_axis(:,2,1,link,t),'zdata',coor_axis(:,3,1,link,t));
        set(h_axis(2,link), 'xdata',coor_axis(:,1,2,link,t),'ydata',coor_axis(:,2,2,link,t),'zdata',coor_axis(:,3,2,link,t));
        set(h_axis(3,link), 'xdata',coor_axis(:,1,3,link,t),'ydata',coor_axis(:,2,3,link,t),'zdata',coor_axis(:,3,3,link,t));
    end
    if(round(time(t))-time(t)) == 0
        set(h_timer,'string',strcat('t=', num2str(round(10*time(t))/10), '.0'));
    else
        set(h_timer,'string',strcat('t=', num2str(round(10*time(t))/10)));
    end
    drawnow;
end


% Finished
disp('Animation complete');