% Forward kinematics
if ~(exist('T6','file'))
    T_temp = eye(4);
    for i = 0:n_links
        A = simplify(dh(dh_table(i+1,:)));
        T_temp = simplify(T_temp*A);
        evalc(['T' num2str(i) ' = matlabFunction(T_temp, ''file'', ''T' num2str(i) ''', ''vars'',[q1 q2 q3 q4 q5 q6 a1 a2 a3 d1 d4 d6])']);
    end
    disp('m-file created: "T0" - "T6"');
end


% Origos of coordinate systems
if ~(exist('origo','file'))
    origo_temp = vpa(zeros(3,n_links+1));
    for i = 0:n_links
        evalc(['temp = T' num2str(i) '(q)']);
        evalc(['origo_temp(:,' num2str(i)+1 ') = temp(1:3,4)']);
    end
    matlabFunction(origo_temp, 'file', 'origo', 'vars', [q1 q2 q3 q4 q5 q6 a1 a2 a3 d1 d4 d6]);
    disp('m-file created: "origo"');
end
% oc = origo(:,6);


% Centers of mass
if ~(exist('rc','file'))
    rc_temp = vpa(zeros(3,n_links));
    
    T_temp = T0(q);                                             % T1 istadenfor?
    rc_temp(:,1) = simplify(origo(q,1) - lc(1)*T_temp(1:3,3));  % SJEKK OM RETT
    T_temp = T2(q);
    rc_temp(:,2) = simplify(origo(q,2) + lc(2)*T_temp(1:3,1));
    T_temp = T4(q);
    rc_temp(:,3) = simplify(origo(q,6) + lc(3)*T_temp(1:3,2));
    rc_temp(:,4) = simplify(origo(q,6) + lc(4)*T_temp(1:3,2));
    T_temp = T5(q);
    rc_temp(:,5) = simplify(origo(q,6) - lc(5)*T_temp(1:3,3));
    rc_temp(:,6) = simplify(origo(q,6) - lc(6)*T_temp(1:3,3));
    
    matlabFunction(rc_temp, 'file', 'rc', 'vars', [q1 q2 q3 q4 q5 q6 a1 a2 a3 d1 d4 d6 lc1 lc2 lc3 lc4 lc5 lc6]);
    disp('m-file created: rc"');
end


% Z-axis
if ~(exist('z6','var'))
    for i = 0:n_links
        evalc(['T_temp = T' num2str(i) '(q)']);
        evalc(['z' num2str(i) ' = simplify(T_temp(1:3,3))']);
    end
end


% Potenial energy
if ~(exist('mat_g','file'))
    P = 0;
    g_vector = vpa(zeros(n_links, 1));
    for i = 1:n_links
        rc_temp = rc(q,i);
        P = P + eval(['m(' num2str(i) ')*g*rc_temp(3)']);
        evalc(['g_vector(' num2str(i) ') = simplify(diff(P, q' num2str(i) '))']);
    end
    matlabFunction(g_vector, 'file', 'mat_g', 'vars', [q1 q2 q3 q4 q5 q6 a1 a2 a3 d1 d4 d6 lc1 lc2 lc3 lc4 lc5 lc6 m1 m2 m3 m4 m5 m6 g]);
end


% Kinetic energy & Euler-Lagrange
if ~(exist('mat_M','file'))
    Jw0 = vpa(zeros(3,n_links));
    M_temp = 0;
    for i = 1:n_links
    disp(['link ' num2str(i)]);
        evalc(['Jv' num2str(i) '= vpa(zeros(3,n_links))']);
        for j = 1:i
            disp('.')
            evalc(['Jv' num2str(i) '(:,j) = simplify(cross(z' num2str(j-1) ', (rc(q,' num2str(i) ') - origo(q,' num2str(j-1) '))))']);
        end

        evalc(['Jw' num2str(i) ' = Jw' num2str(i-1)]);
        evalc(['Jw' num2str(i) '(:,i) = z' num2str(i-1)]);

        evalc(['J' num2str(i) ' = [Jv' num2str(i) '; Jw' num2str(i) ']']);
        
        evalc(['T_temp = T' num2str(i) '(q)']);
        
        mJVJV = eval(['simplify(m(' num2str(i) ')*Jv' num2str(i) '''*Jv' num2str(i) ')']);
        
        disp(',')
        
        JwRIRJW = eval(['simplify(Jw' num2str(i) '''*T_temp(1:3,1:3)*I' num2str(i) '*T_temp(1:3,1:3)''*Jw' num2str(i) ')']);
        
        disp(',')
        
        M_temp = M_temp + mJVJV + JwRIRJW;
    end
    matlabFunction(M_temp, 'file', 'mat_M', 'vars', [q1 q2 q3 q4 q5 q6 a1 a2 a3 d1 d4 d6 lc1 lc2 lc3 lc4 lc5 lc6 m1 m2 m3 m4 m5 m6 g I1xx I1yy I1zz I1xy I1xz I1yz I2xx I2yy I2zz I2xy I2xz I2yz I3xx I3yy I3zz I3xy I3xz I3yz I4xx I4yy I4zz I5xx I5yy I5zz I6xx I6yy I6zz]);
end

if ~(exist('mat_C','file'))
    C_temp = vpa(zeros(n_links));
    M_temp = mat_M(q);
    for k = 1:size(C_temp,1)
        for j = 1:size(C_temp,2)
            for i = 1:n_links
                c1 = diff(M_temp(k,j),q(i));
                c2 = diff(M_temp(k,i),q(j));
                c3 = diff(M_temp(i,j),q(k));
                C_temp(k,j) = C_temp(k,j) + (1/2)*(c1 + c2 - c3)*qd(i);
                
                disp(['link ' num2str(k) '-' num2str(j) '-' num2str(i)]);
            end
        end
    end
    matlabFunction(C_temp, 'file', 'mat_C', 'vars', [q1 q2 q3 q4 q5 q6 q1d q2d q3d q4d q5d q6d a1 a2 a3 d1 d4 d6 lc1 lc2 lc3 lc4 lc5 lc6 m1 m2 m3 m4 m5 m6 g I1xx I1yy I1zz I1xy I1xz I1yz I2xx I2yy I2zz I2xy I2xz I2yz I3xx I3yy I3zz I3xy I3xz I3yz I4xx I4yy I4zz I5xx I5yy I5zz I6xx I6yy I6zz]);
end



% Geometric Jacobian
if ~(exist('mat_J','file'))
    J_temp = vpa(zeros(6,n_links));
    for i = 1:n_links
        evalc(['J_temp(1:3,i) = cross(z' num2str(i-1) ', (origo(q,6) - origo(q,' num2str(i-1) ')))']);
        evalc(['J_temp(4:6,i) = z' num2str(i-1)]);
    end
    J_temp = simplify(J_temp);
    matlabFunction(J_temp, 'file', 'mat_J', 'vars', [q1 q2 q3 q4 q5 q6 a1 a2 a3 d1 d4 d6]);
end

if ~(exist('mat_J_dot','file'))
    J_dot_temp = vpa(zeros(6,n_links));
    for i = 1:n_links
        disp(i);
        evalc(['J_dot_temp = J_dot_temp + diff(mat_J(q), q' num2str(i) ')*q' num2str(i) 'd']);
    end
    J_dot_temp = simplify(J_dot_temp);
    matlabFunction(J_dot_temp, 'file', 'mat_J_dot', 'vars', [q1 q2 q3 q4 q5 q6 q1d q2d q3d q4d q5d q6d a1 a2 a3 d1 d4 d6]);
end



% Finished
modeling_complete = 1;
disp('Modeling complete');