% Plotting


figure;
gamma = length(x)-0;

subplot(3,2,1), 
stairs(time(1:gamma), x(1:gamma,1:3)-r(1:3,1:gamma)','linewidth',1), 
xlabel('time [s]'), ylabel('p_e [m]'), 
legend('x', 'y', 'z'), title('Position error'), grid on;

subplot(3,2,3), 
stairs(time(1:gamma), xd(1:gamma,1:3)-rd(1:3,1:gamma)','linewidth',1), 
xlabel('time [s]'), ylabel('p''_e [m/s]'), 
legend('x''', 'y''', 'z'''), title('Velocity error'), grid on;

subplot(3,2,2), 
stairs(time(1:gamma), x(1:gamma,4:6)-r(4:6,1:gamma)','linewidth',1), 
xlabel('time [s]'), ylabel('\theta_e [rad]'), 
legend('\phi', '\theta', '\psi'), title('Orientation error'), grid on;

subplot(3,2,4), 
stairs(time(1:gamma), xd(1:gamma,4:6)-rd(4:6,1:gamma)','linewidth',1), 
xlabel('time [s]'), ylabel('\theta''_e [rad/s]'), 
legend('\phi''', '\theta''', '\psi'''), title('Angular velocity error'), grid on;

subplot(3,2,5), 
stairs(time(1:gamma), -F(1:gamma,2),'linewidth',1), 
xlabel('time [s]'), ylabel('F [N]'), grid on, hold on, 
stairs(time(1:gamma), -Fd(2,1:gamma)', 'r--'), hold off, 
legend('F', 'F_d'), title('Force');

subplot(3,2,6), 
stairs(time(1:gamma), -F(1:gamma,2)+Fd(2,1:gamma)','linewidth',1), 
xlabel('time [s]'), ylabel('F_e [N]'), title('Force error'), grid on;

% Finished
disp('Plotting complete');