function [ rpy ] = rpy( R )


    persistent last_alpha;
    if isempty(last_alpha)
        last_alpha = zeros(3,1);
    end
    
    rpy1 = zeros(3,1);
    rpy2 = zeros(3,1);
    
    rpy1(1) = atan2(R(2,1), R(1,1));                % Roll around Z-axis (3. rot. around fixed axes)
    rpy1(2) = atan2(-R(3,1), sqrt(1-R(3,1)^2));     % Pitch around Y-axis
    rpy1(3) = atan2(R(3,2), R(3,3));                % Yaw around X-axis
    
    rpy2(1) = atan2(-R(2,1), -R(1,1));
    rpy2(2) = atan2(-R(3,1), -sqrt(1-R(3,1)^2));
    rpy2(3) = atan2(-R(3,2), -R(3,3));
    
    % Choose solution
    if norm(rpy1-last_alpha) <= norm(rpy2-last_alpha)
        rpy = rpy1;
    else
        rpy = rpy2;
    end
    
    last_alpha = rpy;
end

